/*
 * ParsedGlobalUser.java
 *
 * Created on September 29, 2009, 4:42 PM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package splscli;

import com.seapine.licenseserver.api.GlobalUser;
import com.seapine.licenseserver.api.LSAPI;
import com.seapine.licenseserver.api.LSAPI.EmailType;
import com.seapine.licenseserver.api.LSAPI.PhoneType;
import com.seapine.licenseserver.api.LSAPI.UserType;
import com.seapine.licenseserver.api.LSAPI.SecurityLevel;
import java.util.List;
import java.util.Iterator;
import java.lang.String;

/**
 * Class to parse command line data into a GlobalUser object
 *
 */
public class ParsedGlobalUser extends GlobalUser {
    
    /** Creates a new instance of ParsedGlobalUser */
    public ParsedGlobalUser(GlobalUser user, List<String> args) {
        super(user);
        
        parseArguments(args);
    }
    
    /** Creates a new instance of ParsedGlobalUser */
    public ParsedGlobalUser(List<String> args) {
        super();
        
        parseArguments(args);
    }
    
    private void parseArguments(List<String> args) {
        String ttpro = "";
        String ttpropool = "";
        String tcm = "";
        String tcmpool = "";
        String ttrm = "";
        String ttrmpool = "";
        String scm = "";
        String scmpool = "";
        boolean usernameSet = false;

        Iterator<String> argIter = args.iterator();
        while(argIter.hasNext()) {
            String arg = argIter.next();
            // command data
            if(arg.contains("--username")) {
                if(usernameSet == false) {
                    this.username = OptParser.splitOpt(arg);
                }
            } else if(arg.contains("--newusername")) {
                // newusername trumps username for parsing the user information
                this.username = OptParser.splitOpt(arg);
                usernameSet = true;
            } else if(arg.contains("--firstname")) {
                this.firstName = OptParser.splitOpt(arg);
            } else if(arg.contains("--initials")) {
                this.initial = OptParser.splitOpt(arg);
            } else if(arg.contains("--lastname")) {
                this.lastName = OptParser.splitOpt(arg);
            } else if(arg.contains("--password")) {
                this.password = OptParser.splitOpt(arg);
            } else if(arg.contains("--active")) {
                String val = OptParser.splitOpt(arg);
                
                if(val.contains("yes")) {
                    this.isActive = true;
                } else {
                    this.isActive = false;
                }
            } else if(arg.contains("--emailtype")) {
                String emailTypeOpt = OptParser.splitOpt(arg);
                
                if(emailTypeOpt.contains("smtp")) {
                    this.emailAddressType = EmailType.internetEmail;
                } else if(emailTypeOpt.contains("mapi")) {
                    this.emailAddressType = EmailType.mapiEmail;
                } else if(emailTypeOpt.contains("other")) {
                    this.emailAddressType = EmailType.otherEmail;
                } else{
                    this.emailAddressType = EmailType.internetEmail;
                }
            } else if(arg.contains("--email")) {
                this.emailAddress = OptParser.splitOpt(arg);
            } else if(arg.contains("--phone1type")) {
                String phoneTypeOpt = OptParser.splitOpt(arg);
                
                if(phoneTypeOpt.contains("work")) {
                    this.phoneNumber1Type = PhoneType.workPhone;
                } else if(phoneTypeOpt.contains("fax")) {
                    this.phoneNumber1Type = PhoneType.faxPhone;
                } else if(phoneTypeOpt.contains("home")) {
                    this.phoneNumber1Type = PhoneType.homePhone;
                } else if(phoneTypeOpt.contains("pager")) {
                    this.phoneNumber1Type = PhoneType.pagerPhone;
                } else if(phoneTypeOpt.contains("mobile")) {
                    this.phoneNumber1Type = PhoneType.mobilePhone;
                } else {
                    this.phoneNumber1Type = PhoneType.workPhone;
                }
            } else if(arg.contains("--phone1")) {
                this.phoneNumber1 = OptParser.splitOpt(arg);
            } else if(arg.contains("--phone2type")) {
                String phoneTypeOpt = OptParser.splitOpt(arg);
                
                if(phoneTypeOpt.contains("work")) {
                    this.phoneNumber2Type = PhoneType.workPhone;
                } else if(phoneTypeOpt.contains("fax")) {
                    this.phoneNumber2Type = PhoneType.faxPhone;
                } else if(phoneTypeOpt.contains("home")) {
                    this.phoneNumber2Type = PhoneType.homePhone;
                } else if(phoneTypeOpt.contains("pager")) {
                    this.phoneNumber2Type = PhoneType.pagerPhone;
                } else if(phoneTypeOpt.contains("mobile")) {
                    this.phoneNumber2Type = PhoneType.mobilePhone;
                } else {
                    this.phoneNumber2Type = PhoneType.workPhone;
                }
            } else if(arg.contains("--phone2")) {
                this.phoneNumber2 = OptParser.splitOpt(arg);
            } else if(arg.contains("--forcechangepassword")) {
                String val = OptParser.splitOpt(arg);
                
                if(val.contains("yes")) {
                    this.changePasswordAtLogon = true;
                } else {
                    this.changePasswordAtLogon = false;
                }
            } else if(arg.contains("--preventchangepassword")) {
                String val = OptParser.splitOpt(arg);
                
                if(val.contains("yes")) {
                    this.cannotChangePassword = true;
                } else {
                    this.cannotChangePassword = false;
                }
            } else if(arg.contains("--type")) {
                String val = OptParser.splitOpt(arg);
                
                if(val.contains("user")) {
                    this.userType = UserType.user;
                } else if(val.contains("customer")) {
                    this.userType = UserType.customer;
                } else {
                    this.userType = UserType.user;
                }
            } else if(arg.contains("--address")) {
                this.address = OptParser.splitOpt(arg);
            } else if(arg.contains("--company")) {
                this.company = OptParser.splitOpt(arg);
            } else if(arg.contains("--division")) {
                this.division = OptParser.splitOpt(arg);
            } else if(arg.contains("--department")) {
                this.department = OptParser.splitOpt(arg);
            } else if(arg.contains("--security")) {
                String secLevelOption = "";
                secLevelOption = OptParser.splitOpt(arg);
                
                if(secLevelOption.contains("none")) {
                    this.securityLevel = SecurityLevel.noAccess;
                } else if(secLevelOption.contains("fetch")) {
                    this.securityLevel = SecurityLevel.retrieveUsers;
                } else if(secLevelOption.contains("users")) {
                    this.securityLevel = SecurityLevel.manageUsers;
                } else if(secLevelOption.contains("full")) {
                    this.securityLevel = SecurityLevel.fullControl;
                } else {
                    this.securityLevel = SecurityLevel.noAccess;
                }
            } else if(arg.contains("--singlesignon")) {
                String val = OptParser.splitOpt(arg);
                
                if(val.contains("yes")) {
                    this.singleSignOn = true;
                } else {
                    this.singleSignOn = false;
                }
            } else if(arg.contains("--notes")) {
                this.notes = OptParser.splitOpt(arg);
            } else if(arg.contains("--ttpro")) {
                ttpro = OptParser.splitOpt(arg);
            } else if(arg.contains("--ttpropool")) {
                ttpropool = OptParser.splitOpt(arg);
            } else if(arg.contains("--tcm")) {
                tcm = OptParser.splitOpt(arg);
            } else if(arg.contains("--tcmpool")) {
                tcmpool = OptParser.splitOpt(arg);
            } else if(arg.contains("--ttrm")) {
                ttrm = OptParser.splitOpt(arg);
            } else if(arg.contains("--ttrmpool")) {
                ttrmpool = OptParser.splitOpt(arg);
            } else if(arg.contains("--scm")) {
                scm = OptParser.splitOpt(arg);
            } else if(arg.contains("--scmpool")) {
                scmpool = OptParser.splitOpt(arg);
            }
            
            // consume the argument...
            argIter.remove();
        }
        
        this.licenses = OptParser.parseLicenses(ttpro, ttpropool, tcm, tcmpool, ttrm, ttrmpool, scm,
                scmpool, this.licenses);
    }
    
}
